SystemOrganization addCategory: #'Polymorph-EventEnhancements'!

!PositionableStream methodsFor: '*Polymorph-EventEnhancements' stamp: 'gvc 10/31/2006 14:47'!
upToAny: aCollection 
	"Answer a subcollection from the current access position to the 
	occurrence (if any, but not inclusive) of any objects in the given collection in the receiver. If 
	any of these is not in the collection, answer the entire rest of the receiver."
	
	| newStream element |
	newStream := WriteStream on: (collection species new: 100).
	[self atEnd or: [aCollection includes: (element := self next)]]
		whileFalse: [newStream nextPut: element].
	^newStream contents! !

!BlockContext methodsFor: '*Polymorph-EventEnhancements' stamp: 'gvc 10/26/2005 16:16'!
asMinimalRepresentation
	"Answer the receiver."

	^self! !

!BlockContext methodsFor: '*Polymorph-EventEnhancements' stamp: 'gvc 10/26/2005 15:52'!
isValid
	"Answer true so we can be used in event dispatching."

	^true! !

WeakMessageSend weakSubclass: #NonReentrantWeakMessageSend
	instanceVariableNames: 'executing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-EventEnhancements'!

NonReentrantWeakMessageSend weakSubclass: #ExclusiveWeakMessageSend
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-EventEnhancements'!

!ExclusiveWeakMessageSend class methodsFor: 'as yet unclassified' stamp: 'gvc 10/25/2006 18:13'!
newSharedState
	"Answer a new ValueHolder with false as the contents."

	^ValueHolder new contents: false! !

!ExclusiveWeakMessageSend methodsFor: 'as yet unclassified' stamp: 'gvc 10/25/2006 18:16'!
basicExecuting: aValueHolder
	"Set the shared value holder."

	executing _ aValueHolder! !

!ExclusiveWeakMessageSend methodsFor: 'as yet unclassified' stamp: 'gvc 10/25/2006 18:07'!
executing
	"Answer from the shared value holder."

	^executing contents! !

!ExclusiveWeakMessageSend methodsFor: 'as yet unclassified' stamp: 'gvc 10/25/2006 18:06'!
executing: aBoolean
	"Set on the shared value holder."

	executing contents: aBoolean! !

!ExclusiveWeakMessageSend methodsFor: 'as yet unclassified' stamp: 'gvc 10/25/2006 18:13'!
initialize
	"Initialize the receiver."

	executing := self class newSharedState.
	super initialize.! !

!NonReentrantWeakMessageSend methodsFor: 'as yet unclassified' stamp: 'gvc 10/25/2006 18:03'!
execute: aBlock
	"Answer the value of the block or nil if already executing."

	self executing ifTrue: [^nil].
	self executing: true.
	^aBlock ensure: [self executing: false]! !

!NonReentrantWeakMessageSend methodsFor: 'accessing' stamp: 'gvc 10/25/2006 18:03'!
executing
	"Answer the value of executing"

	^ executing! !

!NonReentrantWeakMessageSend methodsFor: 'accessing' stamp: 'gvc 10/25/2006 18:03'!
executing: anObject
	"Set the value of executing"

	executing := anObject! !

!NonReentrantWeakMessageSend methodsFor: 'as yet unclassified' stamp: 'gvc 10/25/2006 18:04'!
initialize
	"Initialize the receiver."

	super initialize.
	self executing: false! !

!NonReentrantWeakMessageSend methodsFor: 'as yet unclassified' stamp: 'gvc 10/25/2006 18:15'!
isValid
	"Answer the superclass vlaue of isValid or false if
	executing is true."

	^self executing
		ifTrue: [false]
		ifFalse: [super isValid]! !

!NonReentrantWeakMessageSend methodsFor: 'as yet unclassified' stamp: 'gvc 10/24/2006 11:42'!
value
	"Answer the superclass value or nil if already executing."

	^self execute: [super value]! !

!NonReentrantWeakMessageSend methodsFor: 'as yet unclassified' stamp: 'gvc 10/24/2006 11:56'!
valueWithArguments: anArray
	"Answer the superclass value or nil if already executing."

	^self execute: [super valueWithArguments: anArray]! !

!NonReentrantWeakMessageSend methodsFor: 'as yet unclassified' stamp: 'gvc 10/24/2006 11:56'!
valueWithEnoughArguments: anArray
	"Answer the superclass value or nil if already executing."

	^self execute: [super valueWithEnoughArguments: anArray]! !

!Object methodsFor: '*Polymorph-EventEnhancements' stamp: 'gvc 10/25/2006 18:18'!
when: anEventSelector
send: aMessageSelector
to: anObject
exclusive: aValueHolder
 
	self
		when: anEventSelector
		evaluate: ((ExclusiveWeakMessageSend
					receiver: anObject
					selector: aMessageSelector)
						basicExecuting: aValueHolder)! !

!Object methodsFor: '*Polymorph-EventEnhancements' stamp: 'gvc 10/25/2006 18:17'!
when: anEventSelector
send: aMessageSelector
to: anObject
with: anArg
exclusive: aValueHolder
 
    self
        when: anEventSelector
        evaluate: ((ExclusiveWeakMessageSend
 		receiver: anObject
		selector: aMessageSelector
		arguments: (Array with: anArg))
			basicExecuting: aValueHolder)! !

!Object methodsFor: '*Polymorph-EventEnhancements' stamp: 'gvc 10/25/2006 18:17'!
when: anEventSelector
send: aMessageSelector
to: anObject
withArguments: anArgArray
exclusive: aValueHolder
 
    self
        when: anEventSelector
        evaluate: ((ExclusiveWeakMessageSend
		receiver: anObject
		selector: aMessageSelector
		arguments: anArgArray)
			basicExecuting: aValueHolder)! !

!Object methodsFor: '*Polymorph-EventEnhancements' stamp: 'gvc 10/24/2006 11:50'!
when: anEventSelector
sendOnce: aMessageSelector
to: anObject
 
    self
        when: anEventSelector
        evaluate: (NonReentrantWeakMessageSend
            receiver: anObject
            selector: aMessageSelector)! !

!Object methodsFor: '*Polymorph-EventEnhancements' stamp: 'gvc 10/24/2006 11:49'!
when: anEventSelector
sendOnce: aMessageSelector
to: anObject
with: anArg
 
    self
        when: anEventSelector
        evaluate: (NonReentrantWeakMessageSend
            receiver: anObject
            selector: aMessageSelector
		arguments: (Array with: anArg))! !

!Object methodsFor: '*Polymorph-EventEnhancements' stamp: 'gvc 10/24/2006 11:49'!
when: anEventSelector
sendOnce: aMessageSelector
to: anObject
withArguments: anArgArray
 
    self
        when: anEventSelector
        evaluate: (NonReentrantWeakMessageSend
            receiver: anObject
            selector: aMessageSelector
		arguments: anArgArray)! !

!SequenceableCollection methodsFor: '*Polymorph-EventEnhancements' stamp: 'gvc 10/31/2006 15:13'!
aggregateRuns: aBlock
	"Answer a new collection of the same species as the
	receiver with elements being collections (of the receiver
	species) containing those elements of the receiver
	for which the given block consecutively evaluates to
	the same object."

	|str r eStr t|
	str := Array new writeStream.
	r := nil.
	eStr := Array new writeStream.
	self do: [:e |
		(t := aBlock value: e) = r
			ifTrue: [eStr nextPut: e]
			ifFalse: [r := t.
					eStr isEmpty
						ifFalse: [str nextPut: (eStr contents as: self species).
								eStr reset].
					eStr nextPut: e]].
	eStr isEmpty ifFalse: [str nextPut: (eStr contents as: self species)].
	^str contents as: self species
	! !
